<?php
defined('_JEXEC') or die;

class PlgSystemPhocagalleryExifButtons extends JPlugin
{
	public function onBeforeRender() {
		$app	= JFactory::getApplication();
		if($app->input->getString('option', FALSE)=='com_phocagallery') {
			if($app->input->getString('view', FALSE) == 'phocagalleryimgs') {
				$bar = JToolBar::getInstance('toolbar');
				$dhtml = '<button class="btn btn-small" onclick="javascript:if(document.adminForm.boxchecked.value==0){alert(\''.JText::_('COM_PHOCAGALLERY_WARNING_RECREATE_MAKE_SELECTION').'\');}else{if(confirm(\''.JText::_('PLG_PHOCAGALLERY_EXIFBUTTON_WARNING_IMPORT_EXIF').'\')){submitbutton(\'phocagalleryimgs.importexif\');}}" ><i class="icon-import" title="'.JText::_('PLG_PHOCAGALLERY_EXIFBUTTON_IMPORT').'"></i> '.JText::_('PLG_PHOCAGALLERY_EXIFBUTTON_IMPORT').'</button>';
				$bar->appendButton('Custom', $dhtml);
			} 
			if($app->input->getString('task', FALSE) == 'importexif') {
				require_once JPATH_ADMINISTRATOR.DS.'components'.DS.'com_phocagallery'.DS.'models'.DS.'phocagalleryimg.php';
				jimport('joomla.application.component.modeladmin');
				phocagalleryimport('phocagallery.file.file');

				$model = JModelAdmin::getInstance('PhocaGalleryImg', 'PhocaGalleryCpModel');
				$cid = JREQUEST::getVar('cid', array(), 'post');
				foreach($cid as $id) {
					$id = intval($id);
					$img = $model->getItem($id);
					$info = array();
					$size = getimagesize(PhocaGalleryFile::getFileOriginal($img->filename), $info);
					if (isset($info['APP13'])) {
						$iptc_data = iptcparse($info['APP13']);
						if (is_array($iptc_data)) {
							$data = @implode($iptc_data["2#025"], ', ');
							$meta = array('id'=> $id, 'title'=>$img->title, 'alias'=>$img->alias);
							$meta['metakey']= utf8_encode($data);
							$meta['metadesc'] = utf8_encode($iptc_data["2#120"][0]);
							if($model->save($meta)) {
								JFactory::getApplication()->enqueueMessage($img->filename." : saving EXIF successful", 'message');
							} else {
								JFactory::getApplication()->enqueueMessage($img->filename." : error on saving EXIF", 'error');
							}
						} else {
							JFactory::getApplication()->enqueueMessage($img->filename." : no EXIF found", 'notice');
						}
					} else {
						JFactory::getApplication()->enqueueMessage($img->filename." : no IPTC found", 'notice');
					}
				}
				$controller = JControllerAdmin::getInstance('PhocaGalleryCpControllerPhocaGalleryImgs');
				$controller->setRedirect(JRoute::_('index.php?option='.$app->input->getString('option', FALSE).'&view='.$app->input->getString('view', FALSE), false));
				$controller->redirect();
			} else {
			}
		}
	}
}